Subject: bug#38966: 27.0.60; Assertion failure in set_cursor_from_row

From: martin rudalics <[email-masked]>
Date: Tue, 7 Jan 2020 18:38:54 +0100

> I thought we were talking about windows with zero lines of text.  One
 > text line is fine, and should not cause any trouble to the current
 > display code.  When testing my patch, I used your code to resized the
 > window to a single 1-pixel high line of text, and saw no problems,
 > including with displaying the cursor.

We are miscommunicating here.  In your previous post you said that

 > >  > I don't expect to have a window that has no lines showing text.  I
 > >  > believe we don't allow creation/resizing of windows to such a small
 > >  > size?  If that's not guaranteed, I'm okay with adding an assertion
 > >  > somewhere, but that would be a separate problem: we never expected
 > >  > such a calamity even before tab-lines were added.
 > >
 > > We did.
 >
 > OK, let me rephrase: _I_ didn't, okay?  IOW, the display code doesn't,
 > and AFAIR never did.
 >
 > (For some reason I seem to make people angry today, and you seem to be
 > one of them.  Apologies -- I don't know for what.)

With my test-popup-2 code you can make the lower window one line high,
hit F2 and get a window without text and cursor.  Which means that the
display code (inadvertently maybe) already does produce and handle
windows with zero lines of text.  I still don't understand why you
thought I was angry when I reported that behavior.

 > I think we should keep that assertion as long as we don't make the
 > code DTRT with such text-less windows.  That assertion only affects
 > developers anyway.  The right time for removing the assertion is when
 > we modify the code to support windows with no text rows.

Agreed.

martin